import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * Created by EUGENEL on 21.04.2017.
 */
public class JoinExample {

    private static final Object guard = new Object();

    private static volatile AtomicInteger counter = new AtomicInteger(0);

    public static void main(String[] args) throws InterruptedException {

        List<Thread> threads = new ArrayList<>();

        for (int i = 0; i < 50000; i++) {
            Thread t = new Thread(() -> {
                try {
                    Thread.sleep(new Random().nextInt(100));
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            });

            threads.add(t);

            t.start();
        }

        System.out.println(Thread.activeCount());

        for (Thread t : threads) {
            t.join();
            System.out.println(t.getState());
        }

        System.out.println(Thread.activeCount());

        System.out.println("counter = " + counter);
    }

    private static final Object o1 = new Object(), o2 = new Object();

    public static int doCalculate1() {
        synchronized (o1) {
            return 0;
        }
    }

    public static int doCalculate2() {
        synchronized (o2) {
            return 0;
        }
    }
}
