import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

/**
 * Created by EUGENEL on 05.05.2017.
 */
public class ThreadPoolExample {

    public static void main(String[] args) throws InterruptedException {

        ThreadPoolExecutor executor = new ThreadPoolExecutor(
                5,
                15,
                10,
                TimeUnit.SECONDS,
                new ArrayBlockingQueue<Runnable>(5000));

        for (int i =0; i<1000; i++) {
            final int num = i;
            executor.execute(() -> {
                System.err.println("Hello from thread pool!! " + num);
                try {
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            });
        }

        System.err.println("All tasks submitted");

        executor.shutdown();
        executor.awaitTermination(10, TimeUnit.SECONDS);
    }
}
