/**
 * Created by EUGENEL on 21.04.2017.
 */
public class ThreadSample {


    private volatile static boolean flag = false;

    public static void main(String[] args) throws InterruptedException {

        Runnable runnable = () -> {
            System.out.println("From thread " + Thread.currentThread().getName());
            try {
                while(true) {
                    if (flag) {
                        System.out.println("Flag is true!!");
                        break;
                    }
                    Thread.yield();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            System.out.println("Thread finished");
        };

        Thread t = new Thread(runnable);
        t.setDaemon(true);
        t.start();

        Thread.sleep(1000);
        flag = true;

        t.join();

        Thread.sleep(1000);
        System.out.println("From main: " + Thread.currentThread().getName());
        System.out.println("Main finished");
    }
}
